package com.anbo.bookstorerest;

import android.app.Activity;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;

import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;

public class BookActivity extends Activity {
    private Book book;
    private EditText titleView, authorView, publisherView, priceView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_book);

        Intent intent = getIntent();
        book = (Book) intent.getSerializableExtra("BOOK");

        TextView headingView = (TextView) findViewById(R.id.book_heading_textview);
        headingView.setText("Book Id=" + book.getId());

        titleView = (EditText) findViewById(R.id.book_title_edittext);
        titleView.setText(book.getTitle());

        authorView = (EditText) findViewById(R.id.book_author_edittext);
        authorView.setText(book.getAuthor());

        publisherView = (EditText) findViewById(R.id.book_publisher_edittext);
        publisherView.setText(book.getPublisher());

        priceView = (EditText) findViewById(R.id.book_price_edittext);
        priceView.setText(book.getPrice() + " ");
    }

    public void deleteBook(View view) {
        DeleteTask task = new DeleteTask();
        task.execute("http://anbobookstorerest.cloudapp.net/Service1.svc/books/" + book.getId());
        finish();
    }

    public void updateBook(View view) {
        // code missing
    }


    public void back(View view) {
        finish();
    }

    private class DeleteTask extends AsyncTask<String, Void, CharSequence> {
        @Override
        protected CharSequence doInBackground(String... urls) {
            String urlString = urls[0];
            try {
                URL url = new URL(urlString);
                HttpURLConnection connection = (HttpURLConnection) url.openConnection();
                connection.setRequestMethod("DELETE");
                int responseCode = connection.getResponseCode();
                if (responseCode % 100 != 2) {
                    throw new IOException("Response code: " + responseCode);
                }
                return "Nothing";
            } catch (MalformedURLException e) {
                return e.getMessage() + " " + urlString;
            } catch (IOException e) {
                return e.getMessage();
            }
        }

        @Override
        protected void onCancelled(CharSequence charSequence) {
            super.onCancelled(charSequence);
            TextView messageView = (TextView) findViewById(R.id.book_message_textview);
            messageView.setText(charSequence);
        }
    }
}
