package com.anbo.bookstorerest;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import java.util.List;

/**
 * Created by anders on 4/13/2016.
 * Meier: Prof Android 4, page 161
 */
public class BookListItemAdapter extends ArrayAdapter<Book> {
    private int resource;

    public BookListItemAdapter(Context context, int resource, List<Book> objects) {
        super(context, resource, objects);
        this.resource = resource;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        Book book = getItem(position);
        String title = book.getTitle();
        String author = book.getAuthor();
        LinearLayout bookView;
        if (convertView == null) {
            bookView = new LinearLayout(getContext());
            String inflater = Context.LAYOUT_INFLATER_SERVICE;
            LayoutInflater li = (LayoutInflater) getContext().getSystemService(inflater);
            li.inflate(resource, bookView, true);
        } else {
            bookView = (LinearLayout) convertView;
        }
        TextView titleView = (TextView) bookView.findViewById(R.id.booklist_item_title);
        TextView authorView = (TextView) bookView.findViewById(R.id.booklist_item_author);
        titleView.setText(title);
        authorView.setText("by " + author);
        return bookView;
    }
}
